program pgas_test
implicit none 

integer            :: myrank, numprocs
integer            :: next_rank, prev_rank
real :: x[0:*]

myrank   = THIS_IMAGE() - 1
numprocs = NUM_IMAGES()
next_rank = mod(myrank+1,numprocs)
prev_rank = mod(myrank-1+numprocs,numprocs)

if (myrank == 0) then
  print *, 'myrank=',myrank, &
         & ' numprocs=',numprocs
endif

! x[myrank]=1000+myrank
x=1000+myrank
sync all
print *, 'myrank=',myrank, &
       & ' x[',prev_rank,']=',x[prev_rank], &
       & ' x[',   myrank,']=',x[   myrank], &
       & ' x[',next_rank,']=',x[next_rank]

end program pgas_test
