#include <stdio.h>
#include <upc.h>

int main(int argc, char **argv)
{
  static shared int x[THREADS];
  int *xloc;
  int prev_rank, next_rank;
 
  xloc = (int*) &(x[MYTHREAD]);
  next_rank = (MYTHREAD+1) % THREADS; 
  prev_rank = (MYTHREAD-1+THREADS) % THREADS; 

  *xloc = 1000 + MYTHREAD;
  /* or x[MYTHREAD] = 1000 + MYTHREAD; */

  if (MYTHREAD == 0) {
    printf("myrank= %d Number of processes = %d\n",MYTHREAD,THREADS); 
  } 

  upc_barrier 20; /* any number */

  printf("myrank= %d x[%d]=%d x[%d]=%d x[%d]=%d\n", 
          MYTHREAD, 
          prev_rank, x[prev_rank],
          MYTHREAD,  *xloc /* or x[MYTHREAD] */,
          next_rank, x[next_rank] );

  return 0;
}
